//------------------------------------
// "chasing northern lights"
// 256b intro
// by wacek/arise
//------------------------------------

//------------------------------------
// global compile variables
//------------------------------------

.var frame = $a0
.var from = $a3 // + $a4
.var line = $a5
.var reg_b = $a6
.var sinus = $1800
.var sid = $d400

//------------------------------------
// main
//------------------------------------

			* = $2002	"charset"
			
charset:	.import binary "assets\siatka08.map",2,30

			* = *		"main"
		
start:		sei

			ldy #$05 
			sty $0286
			jsr $e544

			ldy #0
			sty $d020
			sty $d021

			lda #$4f
			sta $d418
			sta $d417

			// prepare sinus
			// + sid setup
			// + put logo

sd_mloop:	ldx sd_here: #0
			cpx #8
			beq sd_out
			
			lda sid_table1 ,x
			sta $d400 - 1,x
			sta $d407 - 1,x
			sta $d40e - 1,x
						
			txa
			adc #$1d
			sta $07e5,x			
						
			lda sin2tab,x
			sta reg_b
			
			lda makesinus,x				
			tax					
!loop:		lda reg_b
			sta sinus,y					
			sta sinus + $80,y			
			sta sd_rev2: sinus + $7f
			dec sd_rev2
			
			iny
			dex
			bne !loop-
			inc sd_here
			bcc sd_mloop

sd_out:		
!loop:		lda sinus + $40-8,x
			sta sinus + $c0-8,x
			sta $2100-8,x
			inx
			bne !loop-

main_loop:	ldx #$ff
!loop:		cpx $d012
			bne !loop-

			
			ldx #0
			
			stx from			
			stx line
			stx to 

			lda #$04
			sta to + 1
			lda #>sinus			
			sta from + 1			
			sta $d018			
						
drawloop:	ldy frame
			ldx #0
			
!loop:		lda (from),y
			sta to: $dead,x
			iny
			inx
			cpx #40
			bne !loop- 	
			
			rol
			rol
			sta $d416

			ldx line
			lda sinus,x
			
			sec
			adc from
			sta from
			
!skip:		lda to			
			adc #40			
			sta to			
			bcc !skip+			
			inc to + 1			
						
!skip:		inc line			

			lda line			
			cmp #24			
			bne drawloop 			 
			
			inc frame
			
			bcs main_loop

//------------------------------------
// tables
//------------------------------------

			* = *	"tabs"

makesinus:	.byte 5,5,6,6,6,7,9,20
sin2tab:	.byte 0,1,2,3,3,2,1 //,0

sid_table1:	.byte $00,$5a,04,$00,$00,$11,$f2,$ee

//------------------------------------
// includes
//------------------------------------

			* = $20e8	"logo"
			.import binary "assets\logo3chars.imap",0,24

//------------------------------------
// all ends here
//------------------------------------